SystemOrganization addCategory: 'JASVGI-Graphics'!

JASVGICanvas subclass: #JASVGIGraphCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Graphics'!

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 14:32'!
example1
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 10@20 maxHeight: 180 width: 30)
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:06'!
example2
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 30;
		at: 'usa' put: 25;
		at: 'china' put: 20;
		at: 'india' put: 20;
		at: 'vietnam' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiesDesc: dict at: 120@120 zoom: 1) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 07:11'!
example3
 | dict |

	dict := Dictionary new.
	dict at: 'miem' put: 80;
		at: 'md' put: 70;
		at: 'mef' put: 50;
		at: 'opp' put: 50;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPieAngles: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 07:41'!
example4
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 45;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mt' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiePercentage: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 10:51'!
example5
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 15@200 maxHeight: 180 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 10:51'!
example6
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawHorizontalBarGraph: dict at: 15@15 maxWidth: 600 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 16:04'!
example7
  | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 30;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mvotma' put: 8;
		at: 'mi' put: 7;
		at: 'mt' put: 5.

	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,300)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,300)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/20/2016 04:18'!
example8
  | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 30;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mvotma' put: 8;
		at: 'mi' put: 7;
		at: 'mt' put: 5.

	canvas drawPiePercentage: dict at: 10@10 radius: 70 transform: 'translate(100,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 70 transform: 'translate(450,100)'.
	canvas drawHorizontalBarGraph: dict at: 10@10 maxWidth: 180 width: 15 transform: 'translate(100,250)'.
	canvas drawVerticalBarGraph: dict at: 10@10 maxHeight: 180 width: 15 transform: 'translate(450,450)'.

	^canvas contents! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 07:26'!
colorPalette

	^#('aliceblue' 'beige' 'brown' 'burlywood' 'cadetblue' 'chocolate' 'coral' 'cornsilk' 'crimson' 'darkcyan' 'darkgoldenrod' 'darkgray' 'darkgreen' 'darkkhaki' 'darkolivegreen'  'darkred' 'darkslateblue' 'darkslategray' 'firebrick' 'gold' 'goldenrod' 'gray' 'lightblue' 'indigo' 'ivory' 'khaki' 'lavender' 'lightcyan' 'lightgoldenrodyellow' 'lightgray' 'olive' 'peru' 'red' 'saddlebrown' 'steelblue' 'tan')! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:09'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"

	^self drawHorizontalBarGraph: aDictionary 
			at: aPoint 
			maxWidth: maxWidth 
			width: width 
			transform: 'translate(20,20)'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:08'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange |

	group := JASVGITagGroup newNamed: 'horizontalBar'.
	group transform: transform.
	svgGroups at: 'horizontalBar' put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (JASVGITagMarker newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: 'horizontalBar'.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: 'horizontalBar'.
		self addFigure: text toGroup: 'horizontalBar'.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 15.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		graph := self drawRectangleAt: (x @ y) height: width width: graphHeight fillColor: self colorPalette randomPeek stroke: 'black'.
		self addFigure: graph toGroup: 'horizontalBar'.
		self addFigure: text toGroup: 'horizontalBar'.
		self addFigure: text2 toGroup: 'horizontalBar'.
		lateralIndex := lateralIndex + 1.
		y := y + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 15:58'!
drawPieAngles: anglesDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			transform:  'translate(', (radius + 20) printString, ',', (radius + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 15:57'!
drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| group angleSum startPoint labelsX labelsY random palette groupName |

	random := Random new.
	palette := self colorPalette asOrderedCollection.
	startPoint := radius @ 0.
	groupName := UUID new asString.
	group := JASVGITagGroup newNamed: groupName id: UUID new asString.
	group transform: transform.
	svgGroups at: groupName put: group.
	angleSum := 0.
	labelsX := radius + aPoint x + 40.
	labelsY := aPoint y - radius.

	anglesDictionary keysAndValuesDo: [:label :eachAngle | | line pointsString calculatedPoint color percentage rect text |
		calculatedPoint := self getArcPointFor: eachAngle angleSum: angleSum radius: radius.
		pointsString := PrintStream on: String new.
		pointsString nextPutAll: 'M0,0 '. "center of the circle"
		pointsString nextPutAll: (startPoint x printString, ',', startPoint y printString).
		pointsString nextPutAll: ' A', radius printString, ',',radius printString.
		pointsString nextPutAll: ' 1'.
		(eachAngle > 180) ifTrue: [pointsString nextPutAll: ' 1 0 '] ifFalse: [pointsString nextPutAll: ' 0 0 '].
		pointsString nextPutAll: (calculatedPoint x printString, ',', calculatedPoint y printString, ' Z').
		color := palette randomPeek: random.
		palette remove: color.
		line := self drawLine: pointsString contents id: UUID new asString widthPx: '1px' stroke: 'black' fillColor: color.
		self addFigure: line toGroup: groupName.
		angleSum := angleSum + eachAngle.
		startPoint := calculatedPoint.
		rect := self drawRoundRectangleAt: labelsX - 15 @ labelsY height: 15 width: 15 fillColor: color stroke: 'black'.
		self addFigure: rect toGroup: groupName.
		percentage := ((eachAngle * 100) / 360) printShowingDecimalPlaces: 2.
		text := self drawText: (label, ' - ', percentage,'%') at: labelsX @ labelsY + 10.
		self addFigure: text toGroup: groupName.
		labelsY := labelsY + 20.
	].! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 13:36'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 15:56'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius
		transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:18'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom 

	^self drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: true! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/19/2016 13:40'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: showTotal
	| xShift yText prevRadius switch group |

	group := JASVGITagGroup newNamed: 'pies'.
	group transform: 'translate(', aPoint x printString, ',', aPoint y printString,')'.
	yText := aPoint y.
	switch := true.

	showTotal 
	ifTrue: [ | circle text |
		circle := self drawCircleAt: aPoint r: (100 * zoom) fillColor: self colorPalette randomPeek stroke: 'black'.
		text := self drawText: 'Total - 100%' at: aPoint.
		self addFigure: circle toGroup: 'pies'.
		self addFigure: text toGroup: 'pies'.
		prevRadius := (100 * zoom).
		xShift := aPoint x + prevRadius]
	ifFalse: [xShift := aPoint x].

	(aBoolean ifTrue: [collectionPercentage asSortedCollection] ifFalse: [collectionPercentage asSortedCollection reverse])
		do: [:eachValue | | key radius circle text |
			yText := switch ifTrue: [aPoint y + 10] ifFalse: [aPoint y - 10].
			key := collectionPercentage keyAtValue: eachValue.
			radius := eachValue * zoom.
			xShift := xShift + radius + 10.
			circle := self drawCircleAt: (xShift @ aPoint y) r: radius fillColor: self colorPalette randomPeek stroke: 'black'.
			text := self drawText: (key, ' ', eachValue printString, '%') at: ((xShift - radius + 10) @ yText).
			self addFigure: circle toGroup: 'pies'.
			self addFigure: text toGroup: 'pies'.
			prevRadius := radius.
			xShift := xShift + prevRadius + 10.
			switch := switch not.
		].! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:19'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:20'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:06'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"

	^self drawVerticalBarGraph: aDictionary 
			at: aPoint 
			maxHeight: maxHeight 
			width: width 
			transform: 'translate(20,', (maxHeight + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:07'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName |

	groupName := UUID new asString.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 25.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (JASVGITagMarker newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight |
		text := self drawText: key at: (x @ (y + 15)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 30)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		graph := self drawRectangleAt: (x @ (y - graphHeight)) height: graphHeight width: width fillColor: self colorPalette randomPeek stroke: 'black'.
		self addFigure: graph toGroup: groupName.
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		x := x + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 13:21'!
getArcPointFor: angle angleSum: angleSum radius: radius
	"Answer the end point <aPoint> for the arc with angle <angle> and circle angle completion <angleSum> with radius <radius> "
	| endPoint totalAngle |

	totalAngle := angleSum + angle. "the angle of the arc is: from <angleSum> to <totalAngle>"
	"formula: x= cos(radian angle) x radius. 											y= sin(radian angle) x radius "
	endPoint := ((((totalAngle * DecimalFloat pi) / 180) cos) * radius) @ ((((totalAngle * DecimalFloat pi) / 180) sin) * radius). 

	"border cases"
	(totalAngle = 90) ifTrue: [endPoint x: 0; y: radius negated].
	(totalAngle = 270) ifTrue: [endPoint x: 0; y: radius].
 	(totalAngle = 0 or: [totalAngle = 360])  ifTrue: [endPoint y: 0; x: radius].
 	(totalAngle = 180)  ifTrue: [endPoint y: 0; x: radius negated].

	((totalAngle < 90) or: [totalAngle > 270]) 
	ifTrue: [endPoint x: endPoint x abs] 
	ifFalse: [endPoint x: endPoint x abs negated].
	(totalAngle > 180) 
	ifTrue: [endPoint y: endPoint y abs] 
	ifFalse: [endPoint y: endPoint y abs negated].

	^endPoint! !
